// file: $DT/class/tree/v1.0/dt_cal_6.cc
//
// isip include files
//
#include "attribute_node_constants.h"
#include "attribute_node.h"
#include "tree_node.h"
#include "tree.h"
#include "linked_list.h"
#include "decision_tree.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: calculate_pessimistic_prune_cc
//
// arguments:
//  Tree_node* node (input): the node where the pruning occurs
//
// return: logical_1 indicating success
//
// this method calculates the prune value of the node
//
logical_1 Decision_tree::calculate_pessimistic_prune_cc(Tree_node* node_a) {

  float_4 prune_value_a = node_a->get_prune_value_cc();

  if (prune_value_a == (float_4)NULL) {

    int_4 data_nodes_a;
    int_4 num_classes_a;

    node_a->get_num_data_nodes_cc (data_nodes_a);
    node_a->get_num_classes_cc (num_classes_a);
    int_4* count = new int_4[num_classes_a];
    node_a->get_count_cc(count);

    for (int_4 i=0;i<num_classes_a;i++) {
      
      prune_value_a += count[i] * confidence_limit_cc(count[i],0);

    }
    node_a->set_prune_value_cc(prune_value_a);
    
    delete [] count;
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;

}
