// file: $DT/class/decision_tree/v1.0/dt_class_0.cc
//

// system include files
//
#include <strings.h>

// isip include files
//
#include <attribute_node.h>
#include <data_node.h>
#include <tree_node.h>
#include <linked_list.h>
#include <tree.h>
#include "decision_tree.h"

#include <integral_constants.h>
#include <tree_node_constants.h>

// method: classify_data_cc
//
// arguments:
//  char_1* fname_a: (input) the results of the classification goes in
//                   this file
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::classify_data_cc (char_1* fname_a) {

  int_4 count=0;
  int_4 misclassified=0;

  Linked_list* data_list_a = data_list_d;
  Data_node* current_data_file;

  char_1* class_label = (char_1*)NULL;

  // check if output file exists
  //
  if (fname_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"classify_data_cc", (char_1*)"filename is NULL");
  }

  FILE* fp = fopen ((char*)fname_a, "w");
  if (fp == (FILE*)NULL) {
    error_handler_cc((char_1*)"classify_data_cc",
		     (char_1*)"unable to create file for writing");
  }
		       
  // retrieve the class label
  //
  class_label = new char_1[ISIP_MAX_STRING_LENGTH];
  if (class_node_d->get_label_cc(class_label) != ISIP_TRUE) {
    error_handler_cc((char_1*)"classify_data_cc",
                     (char_1*)"unable to get class label from class node");
  }

  while ( data_list_a != (Linked_list*)NULL ) {

    // get current data node to be classified
    //
    current_data_file = (Data_node*)data_list_a->get_node_cc();

    char_1* class_a=new char_1[ISIP_MAX_STRING_LENGTH];

    // put data file thru tree to get its class
    //
    drop_thru_tree_cc( current_data_file, tree_d->get_root_cc() , class_a);

    // check to see if the data has a tagged class
    //
    char_1* actual_class_a=new char_1[ISIP_MAX_STRING_LENGTH];

    // get filename of this data node
    //
    char_1* file_a=new char_1[ISIP_MAX_STRING_LENGTH];
    current_data_file->get_desc_cc( file_a );

    // output data filename to stdout
    //
    fprintf(fp, "%s\t", file_a);

    delete [] file_a;
    
    if ( (current_data_file->get_item_cc( actual_class_a, class_label )) == ISIP_TRUE ) {

      // count number of misclassifications
      //
      if ( strcmp( (char*)actual_class_a, (char*)class_a ) != 0 )
	misclassified++;

      // increment count of data items tested
      //
      count++;

      // output actual class of the data file
      //
      fprintf(fp, "%s\t", actual_class_a);

    }

    // output the classification
    //
    fprintf(fp, "%s\n", class_a);
    
    delete [] class_a;
    delete [] actual_class_a;
	     
    // get next data node
    //
    data_list_a = data_list_a->get_next_cc();

  }

  // display results
  //
  float_4 error_rate = ((float_4)misclassified/(float_4)count)*100;
  
  fprintf (fp, "\n\n\nPercent error: %f\n", error_rate );
  fprintf (fp, "Number of data items:  %ld\n", count );
  fprintf (fp, "Number of misclassifications:  %ld\n", misclassified );

  // clean up
  //
  if (class_label != (char_1*)NULL) {
    delete [] class_label;
  }
  

  // exit gracefully
  //
  return ISIP_TRUE;
}


