// file: $DT/class/decision_tree/v1.0/dt_prune_2.cc
//

// isip include files
//
#include <data_node.h>
#include <linked_list.h>
#include <tree_node.h>
#include <tree_node_constants.h>
#include "decision_tree.h"
#include <integral_constants.h>

// method: drop_thru_prune_cc
//
// arguments:
//  Tree_node* node: (input) the node we are considering to prune
//
// return: a logical_1 indicating status of success
//
logical_1 Decision_tree::drop_thru_prune_cc (Tree_node* node_a) {

  Linked_list* children;
  Tree_node* left_child;
  Tree_node* right_child;
  int_4 max_index;
  
  if (node_a->is_terminal_cc() == ISIP_FALSE) {

    // get children of this node
    //
    children = node_a->get_children_cc();

    left_child = (Tree_node*)children->get_node_cc();
    
    if ((children = children->get_next_cc()) != (Linked_list*)NULL) {
      right_child = (Tree_node*)children->get_node_cc();
    }

    // recursively going down the tree
    //
    drop_thru_prune_cc (left_child);
    drop_thru_prune_cc (right_child);

    // check to see if pruning is needed
    //
    if (calculate_pessimistic_prune_cc(node_a, left_child, right_child,
				       max_index)
	== ISIP_TRUE) {
      
      // do the pruning 
      //
      apply_prune_cc(node_a);
    }
  }
  else {

    // calculate the predicted error of the leaf
    //
    calculate_pessimistic_prune_cc(node_a);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


