// file: $DT/class/decision_tree/v1.0/dt_size_0.cc
//

// isip include files
//
#include "decision_tree.h"
#include "attribute_node.h"
#include "linked_list.h"
#include "data_node.h"
#include "tree.h"

// method: required size method
//
// arguments: none
//
// return: int_4 indicating the size of the decision tree
//
int_4 Decision_tree::size_cc() {
  
  // create size variable and set to the size of default protected
  // data
  //
  int_4 size = sizeof(debug_level_d);
  size += sizeof(mode_d);
  size += sizeof(mode_split_d);
  size += sizeof(mode_search_d);
  size += sizeof(mode_prune_d);
  size += sizeof(mode_smooth_d);
  size += sizeof(mode_display_d);
  size += sizeof(param_fname_d);
  size += sizeof(attr_fname_d);
  size += sizeof(data_fname_d);
  size += sizeof(tree_fname_d);
  size += sizeof(num_of_attributes_d);
  size += sizeof(confidence_limit_d);
  size += sizeof(class_node_d);
  size += sizeof(attribute_list_d);
  size += sizeof(data_list_d);
  size += sizeof(num_classes_d);
  size += sizeof(class_names_d);
  size += sizeof(class_prior_probs_d);
  size += sizeof(num_nodes_d);
  size += sizeof(tree_d);

  // add in the size of param_fname_d
  //
  if (param_fname_d != (char_1*)NULL) {
    size += (strlen((char*)param_fname_d)+1) * sizeof(char_1);
  }
  
  // add in the size of attr_fname_d
  //
  if (attr_fname_d != (char_1*)NULL) {
    size += (strlen((char*)attr_fname_d)+1) * sizeof(char_1);
  }
  
  // add in the size of data_fname_d
  //
  if (data_fname_d != (char_1*)NULL) {
    size += (strlen((char*)data_fname_d)+1) * sizeof(char_1);
  }

  // add in the size of tree_fname_d
  //
  if (tree_fname_d != (char_1*)NULL) {
    size += (strlen((char*)tree_fname_d)+1) * sizeof(char_1);
  }

  // add the size of the class_node_d
  //
  if (class_node_d != (Attribute_node*)NULL) {
    size += class_node_d->size_cc();
  }
  
  // add the size of the list of attributes and each node's size
  //
  if (attribute_list_d != (Linked_list*)NULL) {
    Linked_list* ll = attribute_list_d;
    Attribute_node* attr_node;
    while (ll != (Linked_list*)NULL) {
      size += ll->size_cc();
      attr_node = (Attribute_node*)ll->get_node_cc();
      size += attr_node->size_cc();
      ll = ll->get_next_cc();
    }
  }
  
  // add the size of the list of data and each node's size
  //
  if (data_list_d != (Linked_list*)NULL) {
    Linked_list* ll = data_list_d;
    Data_node* data_node;
    while (ll != (Linked_list*)NULL) {
      size += ll->size_cc();
      data_node = (Data_node*)ll->get_node_cc();
      size += data_node->size_cc();
      ll = ll->get_next_cc();
    }
  }

  // add in the size of class_names_d
  //
  if (class_names_d != (char_1**)NULL) {
    for (int_4 i=0;i<num_classes_d;i++) {
      size += sizeof(class_names_d[i]);
      size += (strlen((char*)class_names_d[i])+1) * sizeof(char_1);
    }
  }

  // add in the size of class_prior_probs_d
  //
  if (class_prior_probs_d != (float_4*)NULL) {
    size += num_classes_d * sizeof(float_4);
  }

  // add in the size of the tree
  //
  size += tree_d->size_cc();

  // exit gracefully
  //
  return size;
}
