// file: $DT/class/tree_node/v1.0/tn_cstr_1.cc
//

// isip include files
//
#include <integral_constants.h>
#include "tree_node.h"
#include "tree_node_constants.h"

// initialize static data
//

logical_1 Tree_node::initialized_d = ISIP_FALSE;
char_1**  Tree_node::classes_d = (char_1**)NULL;
int_4     Tree_node::num_class_d = 0;
int_4     Tree_node::max_class_size_d = TREE_CLASS_ELEMENTS;

// method: constructor
//
// arguments:
//
// return: none
//
// this is the default constructor for the Tree_node class that
// starts with a given node
//
Tree_node::Tree_node() {

  //  printf("Tree_node constructor: %u\n", (uint_2)this);
  
  // initialize internal data
  //
  if (class_init_cc() == ISIP_FALSE) {
    error_handler_cc((char_1*)"Tree_node()",
                     (char_1*)"fatal error initializing Tree_node");
  }
  
  // initialize node parameters
  //
  label_d = (char_1*)NULL;
  children_d = new Linked_list();
  probability_d = (float_4*)NULL;
  count_d = (int_4*)NULL;
  discrete_values_d = (char_1**)NULL;
  data_d = new Linked_list();
  num_data_nodes_d=0;
  num_discrete_values_d=0;
  prune_value_d=0;

  // debugging parameters
  //
  debug_level_d = ISIP_DEBUG_NONE;
  
  // exit gracefully
  //
}






