// file: $DT/class/tree_node/v1.0/tn_cstr_3.cc
//

// isip include files
//
#include <integral_constants.h>
#include "tree_node.h"
#include "tree_node_constants.h"

// include system files
//
#include <string.h>

// method: constructor
//
// arguments: char_1** strings of the discrete values at this node
//            num_discrete_a number of the strings present
//            int_4 operator_d operator used for question
//            char_1* attr_label_a  attribute label
//
// return: none
//
// this is the constructor for the Tree_node class sets the node as
// it is created
//
Tree_node::Tree_node(char_1** discrete_values_a, int_4 num_discrete_a,
		     int_4 operator_a, char_1* attr_label_a) {

  //  printf("Tree_node constructor: %u\n", (uint_2)this);

  // initialize internal data
  //
  if (class_init_cc() == ISIP_FALSE) {
    error_handler_cc((char_1*)"Tree_node()",
		     (char_1*)"fatal error initializing Tree_node");
  }
  
  // set protected data equal to data passed in
  //
  operator_d = operator_a;
  label_d = new char_1[strlen((char*)attr_label_a)+1];
  strcpy((char*)label_d, (char*)attr_label_a);
  num_discrete_values_d = num_discrete_a;
  split_type_d = TREE_NODE_DISCRETE;
  
  // allocate space for the discrete values
  //
  discrete_values_d = new char_1*[num_discrete_a];

  // copy the discrete values into the node
  //
  for ( int_4 i=0; i<num_discrete_a; i++ ) {
    discrete_values_d[i]=new char_1[strlen((char*)*discrete_values_a[i])+1];
    strcpy((char*)*discrete_values_d[i],(char*)*discrete_values_a[i]);
  }

  // initialize node parameters
  //
  children_d = new Linked_list();
  probability_d = (float_4*)NULL;
  count_d = (int_4*)NULL;
  num_class_d=0;
  level_d=0;
  num_data_nodes_d=0;
  data_d = new Linked_list();
  classes_d = (char_1**)NULL;
  prune_value_d = 0;
  
  // debugging parameters
  //
  debug_level_d = ISIP_DEBUG_NONE;
  
  // exit gracefully
  //
}

