// file: $DT/class/tree_node/v1.0/tn_cstr_4.cc
//

// isip include files
//
#include <integral_constants.h>
#include "tree_node.h"
#include "tree_node_constants.h"

// library include files
//
#include <strings.h>

// method: copy constructor
//
// arguments: Tree_node class
//
// return: none
//
// this is the copy constructor for the Tree_node class
//
Tree_node::Tree_node( const Tree_node& old_node ) {

  //  printf("Tree_node constructor: %u\n", (uint_2)this);
  
  Linked_list* ll_ptr;
  Tree_node* node_a;
  Data_node* node2_a;
  
  // initialize internal data
  //
  if (class_init_cc() == ISIP_FALSE) {
    error_handler_cc((char_1*)"Tree_node()",
		     (char_1*)"fatal error initializing Tree_node");
  }

  // copy debug level over
  //
  debug_level_d = old_node.debug_level_d;
  
  // copy split type
  //
  split_type_d = old_node.split_type_d;

  // create new space for strings if they exist, otherwise set to NULL
  //
  if ( old_node.label_d != (char_1*)NULL ) {
    label_d=new char_1[strlen((char*)old_node.label_d)+1];
    strcpy((char*)label_d,(char*)old_node.label_d);
  }
  else {
    label_d= (char_1*)NULL;
  }

  // copy operator_d
  //
  operator_d = old_node.operator_d;
  
  // copy linked list
  //
  children_d = new Linked_list();
  ll_ptr=old_node.children_d;
  while ( node_a != (Tree_node*)NULL ) {
    node_a = (Tree_node*)ll_ptr->get_node_cc();
    children_d->insert_cc((void_p)node_a);
    ll_ptr = ll_ptr->get_next_cc();
  }

  // copy data node linked list
  //
  data_d = new Linked_list();
  ll_ptr=old_node.data_d;
  while ( ll_ptr != (Linked_list*)NULL ) {
    node2_a = (Data_node*)ll_ptr->get_node_cc();
    data_d->insert_cc((void_p)node2_a);
    ll_ptr = ll_ptr->get_next_cc();
  }
  
  num_discrete_values_d=old_node.num_discrete_values_d;

  // allocate space for the discrete values
  //
  if ( num_discrete_values_d )
    discrete_values_d = new char_1*[num_discrete_values_d];
  for ( int_4 i=0; i<num_discrete_values_d; i++ ) {
    discrete_values_d[i] =
      new char_1[strlen((char*)old_node.discrete_values_d[i])+1];
    strcpy((char*)discrete_values_d[i],(char*)old_node.discrete_values_d[i]);
  }

  level_d = old_node.level_d;
  num_data_nodes_d = old_node.num_data_nodes_d;
  prune_value_d = old_node.prune_value_d;
  
  // if these arrays exist, copy into new data, otherwise set to NULL
  //
  if (old_node.probability_d != (float_4*)NULL) {
    probability_d = new float_4[num_class_d];
    for ( int_4 i=0; i<num_class_d; i++ )
      probability_d[i]=old_node.probability_d[i];
  }
  if (old_node.count_d != (int_4*)NULL) {
    count_d = new int_4[num_class_d];
    for ( int_4 i=0; i<num_class_d; i++ )
      count_d[i]=old_node.count_d[i];
  }

  // copy min and max
  //
  min_d = old_node.min_d;
  max_d = old_node.max_d;

  // reset the parent
  //
  parent_d = old_node.parent_d;
  
  // exit gracefully
  //
}
