// file: $DT/class/tree_node/v1.0/tn_del_0.cc
//

// isip include files
//
#include <integral_constants.h>
#include "tree_node.h"
#include "tree_node_constants.h"

// method: this method removes children from a parent node
//
// arguments: none
//
// return: logical status indicating success
//
// this is the method to remove children from a parent node
//
logical_1 Tree_node::delete_children_cc() {

  // delete the children nodes
  //
  if (children_d != (Linked_list*)NULL) {

    Linked_list* ll_temp = children_d;
    Tree_node* tn_temp;

    // delete the nodes contained in the link list
    //
    while ( ll_temp != (Linked_list*)NULL ) {
      tn_temp = (Tree_node*)ll_temp->get_node_cc();
      if ( tn_temp != (Tree_node*)NULL )
	delete tn_temp;
      ll_temp->delete_cc((void_p)tn_temp);
      ll_temp = ll_temp->get_next_cc();
    }
    delete children_d;
    children_d = (Linked_list*)NULL;
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}


