// file: $DT/class/tree_node/v1.0/tn_get_5.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: get_contents_cc
//
// arguments: none
//
// return: string containing formatted data from the node
//
// this method returns the question asked at the node in string form that
// is formatted and tagged with the level it is on
//
logical_1 Tree_node::get_contents_cc(int_4 display_level_a,
				     char_1* output_str_a) {

  // check input arguments
  //
  if (output_str_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"get_contents_cc",
		     (char_1*)"output memory is not allocated");
  }
  
  // allocate memory
  //
  char_1* tmp_output = new char_1[ISIP_MAX_STRING_LENGTH];
  
  // print tag showing level 
  //
  sprintf((char*)tmp_output, "<L%ld> ", level_d);
  
  // format the output
  //
  for ( int_4 i=0; i<level_d; i++ ) {
    strcat((char*)tmp_output, (char*)TREE_NODE_WHITE_SPACE);
  }

  char_1* question = new char_1[ISIP_MAX_STRING_LENGTH];
  get_question_cc(question);
  strcat((char*)tmp_output, (char*)question);
  delete [] question;

  // get count or probability at the node if specified
  //
  if ( display_level_a != DT_DISPLAY_BASIC ) {

    char_1* output_a = new char_1[ISIP_MAX_STRING_LENGTH];

    if ( display_level_a == DT_DISPLAY_COUNT ) {

      if ( count_d == (int_4*)NULL )
	error_handler_cc( (char_1*)"get_contents_cc",
			  (char_1*)"tried to output count when none exists");

      // copy contents of count array into a string
      //
      char_1* count_str = new char_1[ISIP_MAX_STRING_LENGTH];
      print_counts_cc( count_str );
      sprintf( (char*)output_a, "%s %s%s", tmp_output, " c: ", count_str );
      delete [] count_str;
    }

    else {

      if ( probability_d == (float_4*)NULL )
	error_handler_cc( (char_1*)"get_contents_cc",
			  (char_1*)"tried to output prob when none exists");

      // copy contents of prob array into a string
      //
      char_1* prob_str = new char_1[ISIP_MAX_STRING_LENGTH];
      print_probs_cc( prob_str );
      sprintf((char*)output_a, "%s %s%s", tmp_output, " p: ", prob_str);
      delete [] prob_str;
    }
    
    strcpy((char*)tmp_output, (char*)output_a);
    delete [] output_a;
  }

  // if the node is terminal, determine its class
  //
  if ( is_terminal_cc() ) {
    char_1* classify = new char_1[ISIP_MAX_STRING_LENGTH];
    assign_class_cc(classify);
    strcat((char*)tmp_output, (char*)"  ");
    strncat((char*)tmp_output, (char*)classify, strlen((char*)classify)+1);
    delete [] classify;
  }

  strcpy ((char*)output_str_a, (char*)tmp_output);
  delete [] tmp_output;
  
  // return gracefully
  //
  return ISIP_TRUE;
}
