// file: $DT/class/tree_node/v1.0/tn_grow_0.cc
//

// isip include files
//
#include <integral_constants.h>
#include "tree_node.h"
#include "tree_node_constants.h"

// include system files
//
#include <string.h>
#include <memory.h>

// method: growing class method
//
// arguments:
//  char_1* class_name (input) the class name to add into the array
//
// return: logical_1 indicating success
//
// this add the name into the classes_d array, expand the array if
// necessary
//
logical_1 Tree_node::grow_class_cc(char_1* class_name) {

  // check the number of classes assigned
  //
  if (max_class_size_d <= num_class_d) {

    max_class_size_d += TREE_CLASS_ELEMENTS;
    char_1** new_class = new char_1*[max_class_size_d];

    // create new array and copy elements over
    //
    for (int_4 i=0;i<num_class_d;i++) {
      new_class[i] = new char_1[strlen((char*)classes_d[i])+1];
      strcpy((char*)new_class[i], (char*)classes_d[i]);
    }

    // delete the old values in the classes_d
    //
    for (int_4 i=0;i<num_class_d;i++) {
      delete [] classes_d[i];
      classes_d[i] = (char_1*)NULL;
    }
    delete [] classes_d;
        
    // copy the new name
    //
    new_class[num_class_d] = new char_1[strlen((char*)class_name)+1];
    strcpy((char*)new_class[num_class_d], (char*)class_name);
    num_class_d++;

    // set the new pointer
    //
    classes_d = new_class;
  }

  else {

    // copy the new name
    //
    classes_d[num_class_d] = new char_1[strlen((char*)class_name)+1];
    strcpy((char*)classes_d[num_class_d], (char*)class_name);
    num_class_d++;
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}

