#! /usr/bin/sh
#
# file: install.sh
#
# this is the installation script for the ISIP decision tree software
#

# compile and install the classes
#
echo "Installing trace projection classes..."

rm -f $DT/bin/$ISIP_BINARY/*
rm -f $DT/lib/$ISIP_BINARY/*

cd $DT/class/attribute_node/v1.0
make clean
make install 


cd $DT/class/data_node/v1.0
make clean
make install 
make clean

cd $DT/class/tree_node/v1.0
make clean
make install 
make clean

cd $DT/class/linked_list/v1.0
make clean
make install 
make clean

cd $DT/class/param_file/v1.0
make clean
make install 
make clean

cd $DT/class/tree/v1.0
make install 
make clean

cd $DT/class/decision_tree/v1.0
make clean
make install 
make clean

# compile and install the trace passing algorithm
#
echo "Installing decision tree utilities..."
cd $DT/util/analyze_dtree/v1.0
make install 

# the installation is now complete, prompt the user
# 
echo "The installation was successful."

# end of file
#
